# Code generated by rgnonomic/rgo; DO NOT EDIT.

#' @useDynLib floats

#' cum_prod
#'
#' CumProd finds the cumulative product of the first i elements in
#' s and puts them in place into the ith element of the
#' destination dst.
#' It panics if the argument lengths do not match.
#' 
#' At the return of the function, dst[i] = s[i] * s[i-1] * s[i-2] * ...
#' 
#' @param dst is a double vector
#' @param s is a double vector
#' @return A double vector
#' @seelso <https://godoc.org/gonum.org/v1/gonum/floats#CumProd>
#' @export
cum_prod <- function(dst, s) {
	if (!is.double(dst) && !is.null(dst)) {
		stop("Argument 'dst' must be of type 'double' or NULL.")
	}
	if (!is.double(s) && !is.null(s)) {
		stop("Argument 's' must be of type 'double' or NULL.")
	}
	.Call("cum_prod", dst, s, PACKAGE = "floats")
}

#' cum_sum
#'
#' CumSum finds the cumulative sum of the first i elements in
#' s and puts them in place into the ith element of the
#' destination dst.
#' It panics if the argument lengths do not match.
#' 
#' At the return of the function, dst[i] = s[i] + s[i-1] + s[i-2] + ...
#' 
#' @param dst is a double vector
#' @param s is a double vector
#' @return A double vector
#' @seelso <https://godoc.org/gonum.org/v1/gonum/floats#CumSum>
#' @export
cum_sum <- function(dst, s) {
	if (!is.double(dst) && !is.null(dst)) {
		stop("Argument 'dst' must be of type 'double' or NULL.")
	}
	if (!is.double(s) && !is.null(s)) {
		stop("Argument 's' must be of type 'double' or NULL.")
	}
	.Call("cum_sum", dst, s, PACKAGE = "floats")
}
